/*
 * MIT License
 *
 * Copyright (c) 2018-2019 Daniel Cortes
 *
 * Permission is hereby granted, free of charge, to any person obtaining a copy
 * of this software and associated documentation files (the "Software"), to deal
 * in the Software without restriction, including without limitation the rights
 * to use, copy, modify, merge, publish, distribute, sublicense, and/or sell
 * copies of the Software, and to permit persons to whom the Software is
 * furnished to do so, subject to the following conditions:
 *
 * The above copyright notice and this permission notice shall be included in all
 * copies or substantial portions of the Software.
 *
 * THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR
 * IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY,
 * FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL THE
 * AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER
 * LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING FROM,
 * OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN THE
 * SOFTWARE.
 */

package danielcortes.xyz.models.egreso;

import danielcortes.xyz.data.MysqlConnectionHolder;
import danielcortes.xyz.models.caja.Caja;
import danielcortes.xyz.models.caja.CajaDAO;
import danielcortes.xyz.models.caja.MysqlCajaDAO;
import danielcortes.xyz.models.tipo_egreso.TipoEgreso;
import danielcortes.xyz.models.tipo_egreso.TipoEgresoDAO;
import danielcortes.xyz.models.tipo_egreso.MysqlTipoEgresoDAO;

import java.sql.Connection;
import java.sql.PreparedStatement;
import java.sql.ResultSet;
import java.sql.SQLException;
import java.util.ArrayList;
import java.util.List;

public class MysqlEgresoDAO extends EgresoDAO {

    public MysqlEgresoDAO(){
        this.connectionHolder = new MysqlConnectionHolder();
    }

    @Override
    public List<Egreso> findAll() {
        List<Egreso> egresoList = new ArrayList<>();
        try {
            Connection conn = connectionHolder.getConnection();
            PreparedStatement ps = conn.prepareStatement("select * from egresos");
            ResultSet rs = ps.executeQuery();

            egresoList = this.egresosFromResultSet(rs);

            rs.close();
            ps.close();
            conn.close();
        } catch (SQLException e) {
            e.printStackTrace();
        }
        return egresoList;
    }

    @Override
    public List<Egreso> findById(int id) {
        List<Egreso> egresoList = new ArrayList<>();
        try {
            Connection conn = connectionHolder.getConnection();
            PreparedStatement ps = conn.prepareStatement("select * from egresos where id = ?");
            ps.setInt(1,id);
            ResultSet rs = ps.executeQuery();

            egresoList = this.egresosFromResultSet(rs);

            rs.close();
            ps.close();
            conn.close();
        } catch (SQLException e) {
            e.printStackTrace();
        }
        return egresoList;
    }

    @Override
    public List<Egreso> findByCaja(Caja caja) {
        List<Egreso> egresoList = new ArrayList<>();
        try {
            Connection conn = connectionHolder.getConnection();
            PreparedStatement ps = conn.prepareStatement("select * from egresos where caja_id = ?");
            ps.setInt(1, caja.getId());
            ResultSet rs = ps.executeQuery();

            egresoList = this.egresosFromResultSet(rs);

            rs.close();
            ps.close();
            conn.close();
        } catch (SQLException e) {
            e.printStackTrace();
        }
        return egresoList;
    }


    @Override
    public List<Egreso> findByNro(String nro) {
        List<Egreso> egresoList = new ArrayList<>();
        try {
            Connection conn = connectionHolder.getConnection();
            PreparedStatement ps = conn.prepareStatement("select * from egresos where nro = ?");
            ps.setString(1, nro);
            ResultSet rs = ps.executeQuery();

            egresoList = this.egresosFromResultSet(rs);

            rs.close();
            ps.close();
            conn.close();
        } catch (SQLException e) {
            e.printStackTrace();
        }
        return egresoList;
    }

    @Override
    public List<Egreso> findByTipoEgreso(TipoEgreso tipoEgreso) {
        List<Egreso> egresoList = new ArrayList<>();
        try {
            Connection conn = connectionHolder.getConnection();
            PreparedStatement ps = conn.prepareStatement("select * from egresos where tipo_egreso_id = ?");
            ps.setInt(1, tipoEgreso.getId());
            ResultSet rs = ps.executeQuery();

            egresoList = this.egresosFromResultSet(rs);

            rs.close();
            ps.close();
            conn.close();
        } catch (SQLException e) {
            e.printStackTrace();
        }
        return egresoList;
    }

    @Override
    public boolean insertEgreso(Egreso egreso) {
        int updates;
        try {
            Connection conn = connectionHolder.getConnection();
            PreparedStatement ps = conn.prepareStatement("insert into egresos (nro, descripcion, valor, tipo_egreso_id, caja_id) values (?,?,?,?,?)");
            ps.setString(1,egreso.getNro());
            ps.setString(2,egreso.getDescripcion());
            ps.setInt(3,egreso.getValor());
            ps.setInt(4,egreso.getTipoEgreso().getId());
            ps.setInt(5, egreso.getCaja().getId());

            updates = ps.executeUpdate();
            ps.close();

            ps = conn.prepareStatement("select last_insert_id()");
            ResultSet rs = ps.executeQuery();
            rs.next();
            egreso.setId(rs.getInt(1));

            rs.close();
            conn.close();
        } catch (SQLException e) {
            e.printStackTrace();
            return false;
        }
        return updates > 0;
    }

    @Override
    public boolean updateEgreso(Egreso egreso) {
        int updates;
        try {
            Connection conn = connectionHolder.getConnection();
            PreparedStatement ps = conn.prepareStatement("update egresos set nro = ?, descripcion = ?, valor = ?, tipo_egreso_id = ?, caja_id = ? where id = ? ");
            ps.setString(1,egreso.getNro());
            ps.setString(2,egreso.getDescripcion());
            ps.setInt(3,egreso.getValor());
            ps.setInt(4,egreso.getTipoEgreso().getId());
            ps.setInt(5, egreso.getCaja().getId());
            ps.setInt(6, egreso.getId());

            updates = ps.executeUpdate();

            ps.close();
            conn.close();
        } catch (SQLException e) {
            e.printStackTrace();
            return false;
        }
        return updates > 0;
    }

    @Override
    public boolean deleteEgreso(Egreso egreso) {
        int updates;
        try {
            Connection conn = connectionHolder.getConnection();
            PreparedStatement ps = conn.prepareStatement("delete from egresos where id = ? ");
            ps.setInt(1, egreso.getId());

            updates = ps.executeUpdate();

            ps.close();
            conn.close();
        } catch (SQLException e) {
            e.printStackTrace();
            return false;
        }
        return updates > 0;
    }

    @Override
    public int getTotalEgreso(Caja caja) {
        int total = 0;
        try {
            Connection conn = connectionHolder.getConnection();
            PreparedStatement ps = conn.prepareStatement("select sum(valor) from egresos where caja_id = ?");
            ps.setInt(1, caja.getId());
            ResultSet rs = ps.executeQuery();

            rs.next();
            total = rs.getInt(1);

            rs.close();
            ps.close();
            conn.close();
        } catch (SQLException e) {
            e.printStackTrace();
        }
        return total;
    }

}
